/*
Autor            : Erki Suurjaak
Loodud           : 30.12.1999
Viimati muudetud : 19.01.2000

    Globaalmuutujate moodul.
    Defineeritud klassid     : TVariableArray, TVariable, TVariableFiled

    Defineeritud struktuurid : TInitVariableNormal, TInitVariableNoFile,
                               TInitVariableNoFileNoDefault, 
                               TInitVariableNoDefault

    Defineeritud konstandid  : gvaTypeDate, gvaTypeTime, gvaTypeLongTime,
                                gvaTypeNone, gvaTypeOther
                               gvaLengthDate, gvaLengthTime, gvaLengthLongTime,
                                gvaLengthOther, gvaLengthNone
                               gvaMaskNumber, gvaMaskEmpty, gvaMaskNone,
                                gvaMaskDay

    Tpsemad kommentaarid tulevad allpool.



----------------------------------------- TVariableArray


    On defineeritud klass TVariableArray, mida saab kasutada
    muutujavrtuste massiivi haldamiseks, failist lugemiseks ja faili
    kirjutamiseks. Muutujad on kujul char *. Muutujatele saab peale
    panna piiranguid - Mask, Length, FixedLength ja Type.
          Mask on char *, mis koosneb antud muutuja jaoks lubatud
          smbolitest. Kui muutujale on kik smbolid lubatud, siis
          Mask == "".
          Length on int. Nitab muutuja maksimaalset pikkust. Kui muutujal
          pole maksimaalset pikkust, siis Length == 0.
          FixedLength on bool. Nitab muutuja pikkuse fikseeritust. Kui
          FixedLength == true, siis muutuja vib olla ainult kas thi vi
          sama pikk kui Length. Kui FixedLength == false, siis seda piirangut
          pole.
          Type on int. Nitab muutuja tpi. On mned etteantud tbid
          (gvaTypeDate, gvaTypeTime, gvaTypeLongTime, gvaTypeOther vms). Kui
          muutuja pole tpi gvaTypeOther, siis peavad ka tema muud piirangud
          sobima valitud tbiga. Niteks tbil gvaTypeDate peab
          Mask == "0123456789", Length == 8, FixedLength == true.
    Kui muutujale ritatakse omistada vrtust, siis seda vrtust
    kontrollitakse tema piirangute suhtes ja kui see ei sobi, siis
    operatsioon ebannestub. Tpidel gvaTypeDate, gvaTypeTime,
    gvaTypeLongTime on implementeeritud ka sisuline kontroll - muutuja vrtus
    peab olema vastavalt korralik kuupev, kellaaeg vi sekunditega kellaaeg.

    Failis on muutujad kujul MuutujaNimi=vrtus; iga omistus uue rea alguses.
    Kui millegiprast on failis muutujale vrtust kaks korda omistatud, siis
    arvesse lheb viimane. Faili kirjutamisel eelmine fail hvib.

    Kui muutujatemassiivil faili pole (s.o. konstrueerimisel valiti selline
    tp), siis igasugused operatsioonid, mis puutuvad failidesse, sellisel
    juhul tagastavad vrtuse 0. Kui fail on, siis automaatselt
    konstrueerimisel loetakse fail sisse ja destrueerimisel kirjutatakse.

    Muutujamassiivi konstrueerimisel kasutatakse struktuure
    TInitVariableNormal, TInitVariableNoFile, TInitVariableNoFileNoDefault,
    TInitVariableNoDefault. Vastavalt valitud struktuurile luuakse ka massiiv.

    VGA OLULINE! Kui kasutatakse mingit funktsiooni, mis tagastab vrtuse
    tpi char *, siis tuleb kasutajal see ka ise kustutada.

    Sisemine konstruktsioon - kasutatakse muutujate TVariable massiivi.
    Kui muutujad kirjutatakse faili, siis muutujate TVariableFiled massiivi.

    Ideid hilisemaks implementatsiooniks - juurde tbid signed ja unsigned
    short, signed ja unsigned char, signed ja unsigned long. Mingi reaalarvu
    ehk ka. Et muutuja oleks ikka stringi kujul, aga peab vastama nende
    tpide spetsiifikale (vahemik, mrk).

    Meetodid:


      KONSTRUKTORID :

                TVariableArray (TInitVariableNormal *, int, char *)
                               Antakse ette muutujamassiiv elemendi tbiga
                               TInitVariableNormal, suurusega int. Failinimi on
                               char *. Fail loetakse sisse.

                TVariableArray (TInitVariableNoFile *, int)
                               Antakse ette muutujamassiiv elemendi tbiga
                               TInitVariableNoFile, suurusega int. Faili pole.

                TVariableArray (TInitVariableNoFileNoDefault *, int)
                               Antakse ette muutujamassiiv elemendi tbiga
                               TInitVariableNoFile, suurusega int. Faili pole.

                TVariableArray (TInitVariableNoDefault *, int, char *)
                               Antakse ette muutujamassiiv elemendi tbiga
                               TInitVariableNoDefault, suurusega int. Failinimi on
                               char *. Fail loetakse sisse.


      MEETODID :

        bool SetValue (int, char*)     - Annab muutujale numbriga int vrtuse
                                         str, kui str kvalifitseerub selleks
                                         muutujaks. Kui str ei kvalifitseeru
                                         vi antud numbriga muutujat pole, siis
                                         tagastab vrtuse 0 (muidu 1).

        bool SetFileName (char *)      - Paneb muutujatemassiivile uue
                                         failinime ja tagastab vrtuse 1.
                                         Kui operatsioon mingil phjusel
                                         ebannestus (niteks massiivi ei
                                         kirjutatagi faili), siis tagastab
                                         vrtuse 0.

        bool ReadFromFile (char *)     - Loeb muutujad etteantud nimega
                                         failist sisse. Kui operatsioon
                                         mingil phjusel ebannestus (faili
                                         pole vi muutujamassiivi ei peagi
                                         peagi faili kirjutama/lugema), siis
                                         tagastab vrtuse 0, muidu 1.

        bool ReadFromFile ()           - Loeb muutujad muutujatemassiivi
                                         failist sisse. Kui operatsioon
                                         mingil phjusel ebannestus (antud
                                         faili pole vi muutujamassiivi ei
                                         peagi faili kirjutama/lugema), siis
                                         tagastab vrtuse 0, muidu 1.

        bool WriteToFile (char *)      - Kirjutab muutujad etteantud nimega
                                         faili. Kui operatsioon
                                         mingil phjusel ebannestus (faili
                                         pole vi muutujamassiivi ei peagi
                                         peagi faili kirjutama/lugema), siis
                                         tagastab vrtuse 0, muidu 1.

        bool WriteToFile ()            - Kirjutab muutujad muutujatemassiivi
                                         faili. Kui operatsioon
                                         mingil phjusel ebannestus (faili
                                         pole vi muutujamassiivi ei peagi
                                         peagi faili kirjutama/lugema), siis
                                         tagastab vrtuse 0, muidu 1.


      ATRIBUUDID :

        bool GetFixedLength (int)      - Tagastab muutuja #int fikseerituse
                                         (kas muutuja pikkus on konstantne).
                                         Kui int-indat muutujat pole, tagastab
                                         vrtuse 0. Halb muidugi

        char* GetMask (int)            - Tagastab muutuja #int smbolmaski
                                         (milliseid smboleid muutuja
                                         sisaldada vib). Kui antud
                                         muutujat pole, tagastab vrtuse 0.

        char * GetHandle (int)         - Tagastab muutuja #int tunnuse failis.
                                         Kui muutujal seda pole
                                         (muutujatemassiivi ei kirjutata
                                         faili), siis tagastab vrtuse NULL.

        int GetLength (int)            - Tagastab muutuja #int maksimaalse
                                         pikkuse. Kui antud muutujat pole,
                                         siis tagastab vrtuse 0.
                                         Siinkohal on jllegi see halb asi, et
                                         kui muutujal maksimaalset pikkust
                                         pole, siis tagastatakse samuti 0.
                                         Aga pole midagi parata.

        char * operator[] (int)        - Tagastab muutuja #int vrtuse.
                                         Kui antud muutujat pole, siis
                                         tagastab vrtuse NULL.

        char * GetValue (int)          - Tagastab muutuja #int vrtuse. Kui
                                         antud muutujat pole, siis tagastab
                                         vrtuse NULL. Tiesti ekvivalentne
                                         char * operator[] (int) - iga.

---------------------------------------- /TVariableArray


*/

#include <string.h>
#include <fstream.h>
#include <stdlib.h>
#include "utils.cpp"



// ------------------------------- Konstandid ------------------------------


const gvaTypeOther    =  0;   // Sisulise piiranguta tp
const gvaTypeNone     =  0;   // Sama asi, teine nimi
const gvaTypeDate     =  1;   // Kuupev (aaaakkpp)
const gvaTypeTime     =  2;   // Kellaaeg (ttmm)
const gvaTypeLongTime =  3;   // Kellaaeg sekunditega (ttmmss)

const gvaLengthNone     = 0;  // Piiranguteta pikkus
const gvaLengthOther    = 0;  // Sama asi, teine nimi
const gvaLengthDate     = 8;  // Kuupeva pikkus
const gvaLengthTime     = 4;  // Kellaaja pikkus
const gvaLengthLongTime = 6;  // Sekunditega kellaaja pikkus

const char * const gvaMaskNumber = "0123456789";     // Numbrite mask
const char * const gvaMaskEmpty  = "";               // Piiranguteta mask
const char * const gvaMaskNone   = "";               // Sama asi, teine nimi


// ------------------------------ /Konstandid ------------------------------




// ---------------- Vajalikud struktuurid initsialiseerimiseks -------------



// Kige tavalisem tp - kirjutatakse faili, on piirangud, on vaikevrtus
class TInitVariableNormal
{
  public :

  const char * Mask;         // Muutuja lubatud smbolid stringina
  int Length;                // Muutuja maksimaalne pikkus
  bool FixedLength;          // Muutuja pikkuse fikseeritus
  int Type;                  // Muutuja tp; gvaTypeDate, gvaTypeOther vms
                             // Muud reeglid peavad siis ka vastama tbile
  const char * DefaultValue; // Muutuja algvrtus
  const char * HandleInFile; // Muutuja this failis
};


// Faili ei kirjutata, on piirangud, on vaikevrtus
class TInitVariableNoFile
{
  public :

  const char * Mask;         // Muutuja lubatud smbolid stringina
  int Length;                // Muutuja maksimaalne pikkus
  bool FixedLength;          // Muutuja pikkuse fikseeritus
  int Type;                  // Muutuja tp; gvaTypeDate, gvaTypeOther vms
                             // Muud reeglid peavad siis ka vastama tbile
  const char * DefaultValue; // Muutuja algvrtus
};


// Faili ei kirjutata, on piirangud, pole vaikevrtust
class TInitVariableNoFileNoDefault
{
  public :

  const char * Mask;         // Muutuja lubatud smbolid stringina
  int Length;                // Muutuja maksimaalne pikkus
  bool FixedLength;          // Muutuja pikkuse fikseeritus
  int Type;                  // Muutuja tp; gvaTypeDate, gvaTypeOther vms
};                           // Muud reeglid peavad siis ka vastama tbile


// Kirjutatakse faili, on piirangud, pole vaikevrtust
class TInitVariableNoDefault
{
  public :

  const char * Mask;         // Muutuja lubatud smbolid stringina
  int Length;                // Muutuja maksimaalne pikkus
  bool FixedLength;          // Muutuja pikkuse fikseeritus
  int Type;                  // Muutuja tp; gvaTypeDate, gvaTypeOther vms
                             // Muud reeglid peavad siis ka vastama tbile
  const char * HandleInFile; // Muutuja this failis
};



// --------------- /Vajalikud struktuurid initsialiseerimiseks -------------




// -------------------------------- TVariable ------------------------------



class TVariable
{
  protected :


  char* Mask_;         // Muutuja lubatud smbolid stringina
  int Length_;         // Muutuja maksimaalne pikkus
  bool FixedLength_;   // Muutuja pikkuse fikseeritus
  int Type_;           // Muutuja tp; gvaTypeDate, gvaTypeOther vms
                       // Muud reeglid peavad siis ka vastama tbile
  char* Value_;        // Muutuja vrtus

                       // Konstrueerimisel kasutatav funktsioon, mis
                       // kontrollib parameetrite kokkusobivust
  inline void ConstructionCheck
                        (const char * Mask, const int Length,
                         const bool FixedLength, const int Type,
                         const char * DefaultValue);


  public :

  TVariable (const char * Mask, const int Length, const bool FixedLength,
             const int Type, const char * DefaultValue = NULL);

  virtual ~TVariable ();

  // Need kaks funktsiooni on defineeritud selleks, et kui TVariableArray-s
  // on TVariable-massiiv loodud tegelikult TVariableFiled-idest, et siis
  // ei peaks upcastingut tegema.
  virtual char * GetHandle () const {return NULL;};
  virtual char * ForWritingToFile () const {return NULL;};

  const bool SetValue (const char * NewValue);   // Uue vrtuse andmine
  char * GetValue () const;                      // Vrtuse vtmine
  char * GetMask () const;                       // Muutuja maski vtmine
  const GetLength () const;                      // Muutuja maks.pikkuse vtmine
  const bool GetFixedLength () const;            // Muutuja pikkuse fikseerituse vtmine
  const GetType () const;                        // Muutuja tbi saamine

  const bool IsValid (const char * Value) const; // Value sobilikkuse kontroll
};



void TVariable::ConstructionCheck
          (const char * Mask, const int Length,
           const bool FixedLength, const int Type,
           const char * DefaultValue)
{
     int ErrorFound = 0;
     switch (Type)             // Kontroll tuntud tbi jrgi
        {
        case gvaTypeDate :     if (Mask != gvaMaskNumber     // Kui maksimum-
                                 || Length != gvaLengthDate) // pikkus on
                                   ErrorFound = 1;           // erinev tuntust
                               if (strlen(DefaultValue) != 0)
                                 if (!IsDate(DefaultValue))  // Kui vaikevrtus
                                   ErrorFound = 2;           // pole see tp
                               if (FixedLength != true)      // Pikkus PEAB
                                   ErrorFound = 1;           // olema fiks.
                               break;
        case gvaTypeTime :     if (Mask != gvaMaskNumber
                                 || Length != gvaLengthTime)
                                   ErrorFound = 1;
                               if (strlen(DefaultValue) != 0)
                                 if (!IsTime(DefaultValue))
                                   ErrorFound = 2;
                               if (FixedLength != true)      // Pikkus PEAB
                                   ErrorFound = 1;           // olema fiks.
                               break;
        case gvaTypeLongTime : if (Mask != gvaMaskNumber
                                 || Length != gvaLengthLongTime)
                                   ErrorFound = 1;
                               if (strlen(DefaultValue) != 0)
                                 if (!IsLongTime(DefaultValue))
                                   ErrorFound = 2;
                               if (FixedLength != true)      // Pikkus PEAB
                                   ErrorFound = 1;           // olema fiks.
                               break;
        default : break;
        }
     if (ErrorFound == 1) FatalError ("\nTVariable : Length or mask restriction conflicts with data type.\n");
     if (ErrorFound == 2) FatalError ("\nTVariable : Default value conflicts with data type.\n");

                                  // Kui pikkus on konstantne, siis maksimum
     if (!Length && FixedLength)  // peab fikseeritud olema
            FatalError ("\nTVariable : If length is fixed, maximum length must be fixed also.\n");


     if (Type == gvaTypeOther && strlen(DefaultValue) != 0)
      {
      if (Length)           // Kui maksimaalne pikkus on fikseeritud
       if (FixedLength)     // Kui pikkus on konstantne
         {
         if ((strlen(DefaultValue) != Length))
            FatalError ("\nTVariable : Default value length conflicts with length restriction.\n");
         }
       else                 // Kui pikkus pole konstantne, siis tuleb
         {                  // vaadata, ega asi pole pikem kui lubatud
         if (strlen(DefaultValue) > Length)
           FatalError ("\nTVariable : Default value length is longer than allowed maximum.\n");
         };

      if (strlen(Mask))     // Kui Mask on thi, siis piiranguid pole
        {
        for (int p = 0; p < strlen (DefaultValue); p++)   // Vastasel juhul
          if (!strchr (Mask, DefaultValue[p]))            // jupiti kontroll
            FatalError ("\nTVariable : Default value conflicts with mask restriction.\n");
        }
      }

     return;
}


TVariable::TVariable (const char * Mask, const int Length,
                      const bool FixedLength, const int Type,
                      const char * DefaultValue)
{
     ConstructionCheck (Mask, Length, FixedLength, Type, DefaultValue);

     Mask_ = new char[strlen(Mask) + 1];
     strcpy (Mask_, Mask);

     Value_ = new char[strlen(DefaultValue) + 1];
     strcpy (Value_, DefaultValue);

     Length_ = Length;

     FixedLength_ = FixedLength;

     Type_ = Type;

     return;
}


TVariable::~TVariable ()
{
    delete (Mask_);
    delete (Value_);
    return;
}


const bool TVariable::SetValue (const char * NewValue)
{
    if (!IsValid(NewValue))            // Kui uus vrtus on konfliktis
      return false;                    // piirangutega, siis jb asi katki.
    if (strcmp(NewValue, Value_))      // Kui uus on sama, mis eelmine, siis
       {                               // pole mtet vaeva nha
       delete (Value_);
       Value_ = new char[strlen(NewValue) + 1];
       strcpy (Value_, NewValue);
       }
    return true;
}


char * TVariable::GetValue () const
{
   char * tmpValue = new char[strlen(Value_) + 1];
   strcpy (tmpValue, Value_);
   return tmpValue;
}


char * TVariable::GetMask () const
{
   char * tmpValue = new char[strlen(Mask_) + 1];
   strcpy (tmpValue, Mask_);
   return tmpValue;
}


const TVariable::GetLength () const
{
   return Length_;
}


const bool TVariable::GetFixedLength () const
{
   return FixedLength_;
}


const TVariable::GetType () const
{
   return Type_;
}


const bool TVariable::IsValid (const char * Value) const
{
   switch (Type_)
      {
      case gvaTypeDate :     if (strlen(Value) != 0) // Value > ""
                               if (!IsDate(Value))  // Kui vaikevrtus
                                 return false;      // pole see tp
                             break;
      case gvaTypeTime :     if (strlen(Value) != 0)
                               if (!IsTime(Value))
                                 return false;
                             break;
      case gvaTypeLongTime : if (strlen(Value) != 0)
                               if (!IsLongTime(Value))
                                 return false;
                             break;
      case gvaTypeOther :    if (strlen(Value) != 0)
                              {
                              if (Length_) // Kui maksimaalne pikkus on olemas
                               if (FixedLength_)  // Kui pikkus on konstantne
                                {
                                if ((strlen(Value) != Length_)) return false;
                                }
                               else if (strlen(Value) > Length_)
                                   return false;
                              if (strlen(Mask_))
                               {
                               for (int p = 0; p < strlen (Value); p++)
                               if (!strchr (Mask_, Value[p]))
                                 return false;
                               }
                              }
                             break;
      default : break;
      }

   return true;
}



// ------------------------------- /TVariable ------------------------------




// ---------------------------- TVariableFiled -----------------------------



class TVariableFiled : public TVariable
{
  protected :

  char* HandleInFile_; // Muutuja this failis


  public :

  TVariableFiled (const char * Mask, const int Length, const bool FixedLength,
                  const int Type, const char * HandleInFile,
                  const char * DefaultValue = NULL);

  virtual ~TVariableFiled ();

  inline virtual char * GetHandle () const;        // Muutuja this failis
  inline virtual char * ForWritingToFile () const; // Muutuja kuju failis
};                                                 // (This=Vrtus)



TVariableFiled::TVariableFiled (const char * Mask, const int Length,
                                const bool FixedLength, const int Type,
                                const char * HandleInFile,
                                const char * DefaultValue)
 : TVariable (Mask, Length, FixedLength, Type, DefaultValue)
{

     if (!strlen(HandleInFile)) FatalError ("\nTVariable : Variable handle must be at least one char long.\n");


     HandleInFile_ = new char[strlen(HandleInFile) + 1];
     strcpy (HandleInFile_, HandleInFile);

     return;
}


TVariableFiled::~TVariableFiled ()
{
    delete (HandleInFile_);
    return;
}


inline char * TVariableFiled::GetHandle () const
{
   char * tmpValue = new char[strlen(HandleInFile_) + 1];
   strcpy (tmpValue, HandleInFile_);
   return tmpValue;
}


inline char * TVariableFiled::ForWritingToFile () const
{
 char * tmpChar = new char[strlen(HandleInFile_) + strlen(Value_) + 2];
 strcpy (tmpChar, HandleInFile_);
 strcat (tmpChar, "=");
 strcat (tmpChar, Value_);
 return tmpChar;
}



// --------------------------- /TVariableFiled -----------------------------




// ---------------------------- TVariableArray -----------------------------



class TVariableArray
{
 private :

 TVariable** VarArray; // Massiiv, kus muutujaid hoitakse
 int ArraySize_;            // Massiivi suurus
 char * FileName_;          // Konfiguratsioonifaili nimi


 public :
 // Konstruktorit on overloaditud
 TVariableArray                                      // Muutujate
  (const TInitVariableNormal * const Variables, const// algvrtustamine ja
   ArraySize, const char * const FileName);          // failist lugemine
 TVariableArray                                     // Muutujate
  (const TInitVariableNoFile * const Variables,     // algvrtustamine,
   const ArraySize);                                // failist ei loeta
 TVariableArray                                     // Muutujate
  (const TInitVariableNoFileNoDefault * const Variables,// algvrtustamine,
   const ArraySize);                                // pole faili ega vaikevrtust
 TVariableArray                                     // Muutujate
  (const TInitVariableNoDefault * const Variables,  // algvrtustamine,
   const ArraySize, const char * const FileName);   // pole vaikevrtust

 ~TVariableArray ();        // Muutujate kustutamine, ehk ka failikirjutamine
 const bool SetValue (const Number,                      // Mingi elemendi
                      const char * const NewValue);      // vrtuse muutmine

 const bool SetFileName (const char * const FileName); // Failinime muutmine

 const bool GetFixedLength (const Number) const; // Mingi elemendi fikseeritus
 char* GetMask (const Number) const;        // Mingi elemendi mask
 char* GetHandle (const Number) const;       // Mingi elemendi tunnus failis
 const GetLength (const Number) const;      // Mingi elemendi maks. pikkus
 char * operator[] (const Number) const;    // Mingi elemendi vrtus
 char * GetValue (const Number) const;      // Mingi elemendi vrtus
 const bool ReadFromFile (const char        // Muutujate lugemine failist
                     * const FileName);     //  FileName
 const bool ReadFromFile ();                // Muutujate lugemine konfifailist
 const bool WriteToFile (const char         // Muutujate kirjutamine faili
                    * const FileName);      // nimega FileName
 const bool WriteToFile ();                 // Muutujate kirjutamine konfifaili
};



// Tavaline - on fail, on vaikevrtused
TVariableArray::TVariableArray (const TInitVariableNormal * const Variables,
                                const ArraySize,
                                const char * const FileName)
{
     if (ArraySize <  1 || ArraySize > 32767)         // Kontroll ikka peal
        FatalError ("\nTVariableArray : Array can be 1..32767 elements long.\n");

     ArraySize_ = ArraySize;
     FileName_ = new char[strlen(FileName) + 1];
     strcpy (FileName_, FileName);


     VarArray = new TVariable*[ArraySize_];
     int i;
     for (i = 0; i < ArraySize_; i++)
      {
          VarArray[i] = new TVariableFiled (Variables[i].Mask,
                                            Variables[i].Length,
                                            Variables[i].FixedLength,
                                            Variables[i].Type,
                                            Variables[i].HandleInFile,
                                            Variables[i].DefaultValue);
      }

     ReadFromFile ();

     return;
}


// Pole faili, on vaikevrtused
TVariableArray::TVariableArray (const TInitVariableNoFile * const Variables,
                                const ArraySize)
{
     if (ArraySize <= 0 || ArraySize > 32767)         // Kontroll ikka peal
        FatalError ("\nTVariableArray : Array can be 1..32767 elements long.\n");
     ArraySize_ = ArraySize;
     FileName_ = NULL;

     VarArray = new TVariable*[ArraySize_];
     int i;
     for (i = 0; i < ArraySize_; i++)
      {
          VarArray[i] = new TVariable (Variables[i].Mask,
                                       Variables[i].Length,
                                       Variables[i].FixedLength,
                                       Variables[i].Type,
                                       Variables[i].DefaultValue);
      }

     return;
}


// Pole faili, pole vaikevrtusi
TVariableArray::TVariableArray (const TInitVariableNoFileNoDefault *
                                const Variables, const ArraySize)
{
     if (ArraySize <= 0 || ArraySize > 32767)         // Kontroll ikka peal
        FatalError ("\nTVariableArray : Array can be 1..32767 elements long.\n");
     ArraySize_ = ArraySize;
     FileName_ = NULL;

     VarArray = new TVariable*[ArraySize_];
     int i;
     for (i = 0; i < ArraySize_; i++)
      {
          VarArray[i] = new TVariable (Variables[i].Mask,
                                       Variables[i].Length,
                                       Variables[i].FixedLength,
                                       Variables[i].Type);
      }

     return;
}


// On fail, pole vaikevrtusi
TVariableArray::TVariableArray (const TInitVariableNoDefault * const Variables,
                                const ArraySize, const char * const FileName)
{
     if (ArraySize <= 0 || ArraySize > 32767)         // Kontroll ikka peal
        FatalError ("\nTVariableArray : Array can be 1..32767 elements long.\n");
     ArraySize_ = ArraySize;
     FileName_ = new char[strlen(FileName) + 1];
     strcpy (FileName_, FileName);

     VarArray = new TVariable*[ArraySize_];
     int i;
     for (i = 0; i < ArraySize_; i++)
      {
          VarArray[i] = new TVariableFiled (Variables[i].Mask,
                                            Variables[i].Length,
                                            Variables[i].FixedLength,
                                            Variables[i].Type,
                                            Variables[i].HandleInFile);
      }

     ReadFromFile ();

     return;
}


TVariableArray::~TVariableArray (void)
{
     int i;
     WriteToFile();

     // Kikidele muutujaobjektidele kinga
     for (i = 0; i < ArraySize_; i++)
      delete (VarArray[i]);
     delete VarArray;

     delete FileName_; // Kui ka faili pole, siis NULLi vib rmuga kustutada

     return;
}


const bool TVariableArray::SetValue (const Number,
                                     const char * const NewValue)
{
    if (Number < 0 || Number >= ArraySize_)     // Kui stitav element
      return false;                             // ei kuulu massiivi

    return VarArray[Number]->SetValue (NewValue);
}


const bool TVariableArray::SetFileName (const char * const FileName)
{
    if (FileName_ == NULL) return false;  // Kui konfifaili ei peagi olema
    if (!strcmp (FileName, FileName_)) return true;

    delete FileName_;
    FileName_ = new char[strlen(FileName) + 1];
    strcpy (FileName_, FileName);

    return true;
}


const bool TVariableArray::GetFixedLength (const Number) const
{
    if (Number < 0 || Number >= ArraySize_) return false;

    return VarArray[Number]->GetFixedLength ();
}


char * TVariableArray::GetMask (const Number) const
{
    if (Number < 0 || Number >= ArraySize_) return false;

    char * tmp = VarArray[Number]->GetMask ();
    return tmp;
}


char* TVariableArray::GetHandle (const Number) const
{
    if (FileName_ == NULL) return false;  // Kui konfifaili ei peagi olema

    if (Number < 0 || Number >= ArraySize_) return false;

    char * tmp = VarArray[Number]->GetHandle();
    return tmp;
}


const TVariableArray::GetLength (const Number) const
{
    if (Number < 0 || Number >= ArraySize_) return false;

    return VarArray[Number]->GetLength ();
}


char * TVariableArray::operator[] (const Number) const
{
    if (Number < 0 || Number >= ArraySize_) return false;

    char * tmp = VarArray[Number]->GetValue ();
    return tmp;
}


char * TVariableArray::GetValue (const Number) const
{
    return operator[] (Number);
}


const bool TVariableArray::ReadFromFile (const char * const FileName)
{
     if (FileName_ == NULL) return false; // Kui faili pole, ei tohi ka lugeda

     if (strlen(FileName))  // Kui failinimi antud
      {
      ifstream ConfigFile (FileName);
      if (ConfigFile)
       {
       char Row[201];
       while (!ConfigFile.eof())
        {
        ConfigFile.getline (Row, 200);
        // getline loeb stringi sisse ka reavahe, see tuleb eemaldada
        if (Row[strlen(Row) - 1] = '\n') Row[strlen(Row) - 1] = '\x0';

        if (strchr (Row, '='))  // Kui rida on omistamine, peab seal vrdusmrk olema
         {
         for (int i = 0; i < ArraySize_; i++)
          {
          const char *HandleName = VarArray[i]->GetHandle();

          // Kui loetud stringi esimene pool htib mingi muutujathisega, siis..
          if (!strncmp (Row, HandleName, strlen(HandleName)))
           {
           int tmpSize = strlen(Row) - strlen(HandleName) - 1;
           char * tmpChar = new char[tmpSize + 1];
           strncpy (tmpChar, Row + strlen(HandleName) + 1, tmpSize);
           tmpChar[tmpSize] = '\0';
           VarArray[i]->SetValue (tmpChar); // Vrtuse kontroll toimub massiivis
           delete tmpChar;
           delete HandleName;
           break;
           }
          }
         }
        }
       ConfigFile.close;
       }
      else return false;
      }
      else return false;
     return true;
};


const bool TVariableArray::ReadFromFile ()
{
     return ReadFromFile (FileName_);
};


const bool TVariableArray::WriteToFile (const char * const FileName)
{
     if (FileName_ == NULL) return false; // Kui faili pole, siis ei tohi ka
                                          // kirjutada - muutujatel pole tunnuseid
     if (strlen(FileName))
      {
      ofstream ConfigFile;
      ConfigFile.open (FileName);
      if (ConfigFile)
       {
       for (int i = 0; i < ArraySize_; i++)
        {
        char * Line = VarArray[i]->ForWritingToFile ();
        ConfigFile << Line << '\n';
        delete Line;
        }
       }
      else return false;
      ConfigFile.close;
      }
     else return false;
     return true;
};


const bool TVariableArray::WriteToFile ()
{
 return WriteToFile (FileName_);
};



// --------------------------- /TVariableArray -----------------------------




// ----------------------------- Peaprogramm -------------------------------



// Peaprogramm, klassi TVariableArray mnede vimaluste nitamiseks.
// Programmis saab sisestada paar vrtust. Need kirjutatakse faili.
// See programm on tiesti mttetu.
#include <conio.h>
int main (void)
{
   const Elements = 4;
   const char * const FileName = "test.cfg";
   enum {DateEntered, TimeEntered, LongTimeEntered, StringEntered};


   TInitVariableNoDefault InitArray[Elements] =
    {
       {gvaMaskNumber, gvaLengthDate,     true,  gvaTypeDate,     "DateEntered"},
       {gvaMaskNumber, gvaLengthTime,     true,  gvaTypeTime,     "TimeEntered"},
       {gvaMaskNumber, gvaLengthLongTime, true,  gvaTypeLongTime, "LongTimeEntered"},
       {gvaMaskNone,   gvaLengthNone,     false, gvaTypeOther,    "StringEntered"},
    };

   TVariableArray Variables (InitArray, Elements, FileName);

   char * TempChr = NULL;
   char Key;
   int StillAtIt = 1;


   do
    {
    clrscr();

    TempChr = Variables[DateEntered];
    cout << "1. Enter date (YYYYMMDD). Entered date : " << TempChr << '\n';
    delete TempChr;

    TempChr = Variables[TimeEntered];
    cout << "2. Enter time (HHMM). Entered time : " << TempChr << '\n';
    delete TempChr;

    TempChr = Variables[LongTimeEntered];
    cout << "3. Enter time (HHMMSS). Entered time : " << TempChr << '\n';
    delete TempChr;

    TempChr = Variables[StringEntered];
    cout << "4. Enter string. Entered string : " << TempChr << '\n';
    delete TempChr;

    cout << "5. Exit\n\nMake your choice : ";


    Key = getch();

    switch (Key)
    {
    case '1' :
          cout << "\nEnter date : ";
          TempChr = new char[130];
          if (cin.peek() == '\n') cin.get();
          cin.get (TempChr, 128);

          if (!Variables.SetValue (DateEntered, TempChr))
           cout << "\nError! Entered value is not a date. Press any key to continue.\n",
          getch();
          delete TempChr;
          break;
    case '2' :
          cout << "\nEnter time : ";
          TempChr = new char[130];
          if (cin.peek() == '\n') cin.get();
          cin.get (TempChr, 128);

          if (!Variables.SetValue (TimeEntered, TempChr))
           cout << "\nError! Entered value is not a time. Press any key to continue.\n",
          getch();
          delete TempChr;
          break;
    case '3' :
          cout << "\nEnter long time : ";
          TempChr = new char[130];
          if (cin.peek() == '\n') cin.get();
          cin.get (TempChr, 128);

          if (!Variables.SetValue (LongTimeEntered, TempChr))
           cout << "\nError! Entered value is not a long time. Press any key to continue.\n",
          getch();
          delete TempChr;
          break;
    case '4' :
          cout << "\nEnter string : ";
          TempChr = new char[130];
          if (cin.peek() == '\n') cin.get();
          cin.get (TempChr, 128);

          Variables.SetValue (StringEntered, TempChr);
          delete TempChr;
          break;
    case '5' :
          StillAtIt = 0;
          break;
    default : break;
    };
   } while (StillAtIt);


   clrscr();
   return 0;
}



// ---------------------------- /Peaprogramm -------------------------------


